<template>
  <div class="app-container">
    <el-drawer
      v-bind="$attrs"
      v-if="onOpen"
      v-on="$listeners"
      @opened="onOpen"
      @close="onClose"
      style="padding-left: 20px"
    >
      <el-row
        :gutter="10"
        class="mb8"
        style="margin-left: 25px; margin-top: 10px; margin-right: 0px"
      >
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['project:surProjectUserInfo:add']"
            >添加</el-button
          >
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['project:surProjectUserInfo:remove']"
            >删除</el-button
          >
        </el-col>
        <right-toolbar
          :showSearch.sync="showSearch"
          @queryTable="getList"
        ></right-toolbar>
      </el-row>
      <el-table
        v-loading="loading"
        :data="surProjectUserInfoList"
        @selection-change="handleSelectionChange" stripe
      >
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column
          label="单位名称"
          prop="deptName"
          align="left"
          show-overflow-tooltip
        />
        <el-table-column label="单位类型" align="center" prop="deptType">
          <template slot-scope="scope">
            <dict-tag :options="dict.type.sys_dept_type" :value="scope.row.deptType" />
          </template>
        </el-table-column>
        <el-table-column label="职务类型" align="center" prop="jobType">
          <template slot-scope="scope">
            <el-select
              v-model="scope.row.jobType"
              placeholder="请选择职务类型"
              @change="changeJobType(scope.row, $event)"
            >
              <el-option
                v-for="item in dict.type.sys_job_type"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </template>
        </el-table-column>
        <el-table-column label="人员名称" align="center" prop="nickName" />
        <el-table-column label="联系电话" align="center" prop="phonenumber" />
      </el-table>
      <pagination
        v-show="total > 0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
      <el-dialog
        :title="title"
        v-if="open"
        :visible.sync="open"
        width="680px"
        append-to-body
        :close-on-click-modal="false"
        :close-on-press-escape="false"
      >
        <el-form ref="form" :model="form" :rules="rules" label-width="120px">
          <el-form-item label="项目名称">
            <el-input
              placeholder="请输入项目名称"
              v-model="form.projectName"
              :disabled="true"
            ></el-input>
          </el-form-item>
          <el-form-item label="所属单位" prop="deptId">
            <treeselect
              v-model="form.deptId"
              :options="deptOptions"
              :show-count="true"
              placeholder="请选择所属单位"
              @select="deptChange"
            />
          </el-form-item>
          <el-form-item label="职务类型" prop="jobType">
            <el-select
              v-model="form.jobType"
              filterable
              placeholder="请选择职务类型"
              style="width: 100%"
            >
              <el-option
                v-for="dict in dict.type.sys_job_type"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="项目人员" prop="userIds">
            <el-select
              ref="user"
              v-model="form.userIds"
              filterable
              multiple
              clearable
              placeholder="请选择项目人员"
              style="width: 100%"
            >
              <el-option
                v-for="item in userOptions"
                :key="item.userId"
                :label="item.nickName"
                :value="item.userId"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="人员备注" prop="remark">
            <el-input v-model="form.remark" placeholder="请输入人员备注" />
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog>
    </el-drawer>
  </div>
</template>

<script>
import {
  listSurProjectUserInfo,
  delSurProjectUserInfo,
  addSurProjectUserInfo,
  updateSurProjectUserInfo,
  findUserByDeptId,
} from "@/api/project/surProjectUserInfo";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  components: { Treeselect },
  props: {
    formData: {
      projectId: String,
      projectName: String,
    },
  },
  dicts: ["sys_dept_type", "sys_job_type"],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 总条数
      total: 0,
      // 项目人员表格数据
      surProjectUserInfoList: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 是否显示弹出层
      open: false,
      // 弹出层标题
      title: "",
      userIds: [],
      userOptions: [],
      // 单位树选项
      deptOptions: [],
      // 单位名称
      deptName: null,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        projectId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        deptId: [{ required: true, message: "请选择所属单位", trigger: "blur" }],
        jobType: [{ required: true, message: "请选择职务类型", trigger: "blur" }],
        userIds: [{ required: true, message: "请选择项目人员", trigger: "blur" }],
      },
    };
  },
  computed: {},
  watch: {
    formData: {
      handler(value) {
        this.formData = value;
      },
      immediate: true,
    },
  },
  created() {},
  mounted() {},
  beforeDestroy() {},
  methods: {
    onOpen() {
      this.getList();
    },
    onClose() {},
    /** 查询项目人员列表 */
    getList() {
      if (this.formData.projectId) {
        this.loading = true;
        this.queryParams.projectId = this.formData.projectId;
        listSurProjectUserInfo(this.queryParams).then((response) => {
          this.surProjectUserInfoList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      }
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        projectId: null,
        deptId: null,
        deptName: null,
        deptType: null,
        jobType: null,
        userId: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
      };
      this.userIds = [];
      this.userOptions = [];
      this.resetForm("form");
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getDeptTree();
      this.form.projectId = this.formData.projectId;
      this.form.projectName = this.formData.projectName;
      this.open = true;
      this.title = "添加项目人员";
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 获取单位列表
    getDeptTree() {
      //获取单位列表的接口
      this.$api.publics.getDeptTree().then((response) => {
        this.deptOptions = response.data;
      });
    },
    // 单位改变数据
    deptChange(note) {
      this.userIds = [];
      this.userOptions = [];
      this.form.userIds = [];
      if (note.id == 100) {
        this.$message.error("请选择下级节点数据，当前数据节点未查询到相关人员！");
        return false;
      }
      if (note.children && note.children.length > 10) {
        this.$message.error("请选择下级节点数据，当前数据节点未查询到相关人员！");
        return false;
      }
      if (note && note.id) {
        this.form.deptId = note.id;
        this.getUserList(note.id);
      }
    },
    // 获取人员列表
    getUserList(id) {
      this.loading = true;
      let param = {
        id: this.form.projectId,
        deptId: this.form.deptId,
      };
      //获取人员列表的接口
      findUserByDeptId(param).then((response) => {
        this.loading = false;
        this.userOptions = response.rows;
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id) {
            updateSurProjectUserInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSurProjectUserInfo(this.form).then((response) => {
              this.$modal.msgSuccess("添加成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    // 改变职务类型
    changeJobType(row, val) {
      this.form.id = row.id;
      this.form.jobType = val;
      updateSurProjectUserInfo(this.form).then((response) => {
        this.$modal.msgSuccess("修改成功");
        this.getList();
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除项目人员编号为"' + ids + '"的数据项？')
        .then(function () {
          return delSurProjectUserInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" scoped>
@import "@/styles/mixin.scss";

::v-deep .el-drawer__header {
  display: none;
}
@include action-bar;

.json-editor {
  height: calc(100vh - 33px);
}
</style>
